river = require('../lib/river')

expectUpdate = (expectedNewValues=null, expectedOldValues=null) ->
  (newValues, oldValues) ->
    expect(newValues).toEqual(expectedNewValues)
    expect(oldValues).toEqual(expectedOldValues)

expectUpdates = (expectedValues...) ->
  callCount = 0
  (newValues, oldValues) ->
    [expectedNewValues, expectedOldValues] = expectedValues[callCount]
    expect(newValues).toEqual(expectedNewValues)
    expect(oldValues).toEqual(expectedOldValues)
    callCount++
  

describe "Bounded Queries", ->
  it "Compiles length based queries", ->
    ctx = river.createContext()
    ctx.addQuery 'SELECT * FROM data.win:length(2)', expectUpdates([[foo:1], null],[[foo:2], null],[[foo:3], [foo:1]])
    ctx.push('data', foo:1)
    ctx.push('data', foo:2)
    ctx.push('data', foo:3)
